package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

import static org.junit.Assert.*;

public class TestInstructor {

    @Test
    public void implementationTest() {
        //given and when
        Instructor instructor = new Instructor(123);

        //then
        Assert.assertTrue(instructor instanceof Teacher);
    }

    @Test
    public void inheritanceTest() {
        //given and when
        Instructor instructor = new Instructor(123);

        //then
        Assert.assertTrue(instructor instanceof Person);
    }

    @Test
    public void teachTest() {
        //given
        Instructor instructor = new Instructor(123);
        Student student = new Student(000);

        //when
        instructor.teach(student, 12);

        //then
        Assert.assertEquals(12, student.getTotalStudyTime(), .001);
    }

    @Test
    public void lectureTest() {
        //given
        Instructor instructor = new Instructor(123);
        Student student = new Student(000);
        Student student1 = new Student(001);
        Learner [] learners = {student, student1};

        //when
        instructor.lecture(learners, 1000);

        //then
        Assert.assertEquals(500, student1.getTotalStudyTime(), .001);
    }

}